/**
 * JavaScript for installation AJAX stuff
 * --------------------------------------------------------------------
 * $Revision::                                                        $
 * $Date::                                                            $
 * $Tag:: 0.2.1-FINAL                                                 $
 * $Author::                                                          $
 * --------------------------------------------------------------------
 * Copyright (c) 2003 - 2009 by Roland Haeder
 * Copyright (c) 2009 - 2012 by Mailer Developer Team
 * For more information visit: http://mxchange.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */

// Initialize all navigations
$().ready(function() {
	// Fade default content in
	window.setTimeout("requestAjaxContent('install', 'install_content', '$content[install_page]', true)", 250);

	// Set default tab id
	defaultTabId = '$content[install_page]';

	// Set 'save-changes' button id
	saveChangesId = 'save_changes';

	//-----------------------------------------
	//            Tab navigation
	//-----------------------------------------
	$('a').each(function (i) {
		$(this).on('click', {index:i}, function (event) {
			// Is there a valid index?
			if (indexTranslation[event.data.index] != null) {
				// Prevent default action
				event.preventDefault();

				// Valid found, so initialize the POST request
				requestAjaxContent('install', 'install_content', indexTranslation[event.data.index], true);
			} // END - if
		});
	});

	//-----------------------------------------
	//             Close buttons
	//-----------------------------------------
	$('#install_error_close').click(function () {
		// Close the window
		closeErrorWindow('install');
	});

	$('#install_warning_close').click(function () {
		// Close the window
		closeWarningWindow('install');
	});

	//-----------------------------------------
	//           Footer navigation
	//-----------------------------------------
	$('#finish').click(function () {
		// 'finish' button has been clicked
		doFinishInstallation();
	});

	$('#next_page').click(function () {
		// 'next' button has been clicked
		doFooterPage('install', 'install_content', 'next');
	});

	$('#previous_page').click(function () {
		// 'previous' button has been clicked
		doFooterPage('install', 'install_content', 'previous');
	});

	$('#installer_switch').click(function () {
		// Switch installer (to plain)
		switchInstaller('plain');
	});

	//-----------------------------------------
	//             Save changes
	//-----------------------------------------
	$('#' + saveChangesId).click(function () {
		// Save changes
		saveChanges('install');
	});

	//-----------------------------------------
	//              Drag'N'Drop
	//-----------------------------------------
	$('#install_process').draggable({
		opacity: 0.85
	});

	$('#install_warning').draggable({
		opacity: 0.85
	});

	$('#install_error').draggable({
		opacity: 0.85
	});
});
